﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class urtcmixcat : MonoBehaviour {
    int objno = 0; // set this to the RTcmix instance you are using for this script
    rtcmixmain RTcmix;
    private bool did_start = false;

    float frequency;

    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        String sfpath = Application.dataPath;

        RTcmix.SendScore("rtinput(\"" + sfpath + "/cat1.aif\") ", objno);

        String score = "bus_config(\"STEREO\", \"in 0-1\", \"aux 0-1 out\") " +
            "bus_config(\"AM\", \"aux 0-1 in\", \"out 0-1\") " +
            "modfreq = makeconnection(\"inlet\", 1, 100) " +
            "AM(0, 0, 9999, 1, modfreq) ";

        RTcmix.SendScore(score, objno);

        RTcmix.SendScore("MAXBANG(0.1)", objno);

        frequency = 100.0f;
        did_start = true;
    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetKey(KeyCode.UpArrow))
        {
            frequency = frequency + 10.0f;
        }
        if (Input.GetKey(KeyCode.DownArrow))
        {
            frequency = frequency - 10.0f;
        }

        RTcmix.setpfieldRTcmix(1, frequency, objno);
    }

    // called once for each sample-buffer. data[] contains incoming and outgoing samples
    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 1); // set "0" to "1" for input processing

        if (RTcmix.checkbangRTcmix(objno) == 1)
        {
            RTcmix.SendScore("STEREO(0, 0.7, 0.5, 1, 0.5)  MAXBANG(0.5)", objno);
        }
    }

    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
