﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;


public class localccat : MonoBehaviour {
    int objno = 0; // set this to the RTcmix instance you are using for this script
    rtcmixmain RTcmix;
    private bool did_start = false;

    private getMyTransform localsrc; // to get position relative to 'thecam'

    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
        localsrc = GameObject.FindWithTag("thecam").GetComponent<getMyTransform>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        RTcmix.SendScore("print_on()", objno);

        String sfpath = Application.dataPath;
        RTcmix.SendScore("rtinput(\"" + sfpath + "/cat1.aif\") ", objno);

        String score = "bus_config(\"STEREO\", \"in 0-1\", \"aux 0-1 out\") " +
            "bus_config(\"LOCALIZE\", \"aux 0-1 in\", \"out 0-1\") " +
            "lcdestX = makeconnection(\"inlet\", 1, 10) " +
            "lcdestY = makeconnection(\"inlet\", 2, 10) " +
            "lcdestZ = makeconnection(\"inlet\", 3, 10) " +
            "LOCALIZE(0, 0, 9999, 10, lcdestX,lcdestY, lcdestZ, 0,0,0, 1.0, 3.0, 0, 1, 2, 0.0001, 100) ";

        RTcmix.SendScore(score, objno);

        RTcmix.SendScore("MAXBANG(0.1)", objno);


        did_start = true;
    }

    // Update is called once per frame
    void Update()
    {
        Vector3 srcpos = localsrc.getTransform(gameObject); // this source relative to the 'observer' object
        // note swap of y and z axes                                             
        RTcmix.setpfieldRTcmix(1, srcpos.x, objno);
        RTcmix.setpfieldRTcmix(2, srcpos.z, objno);
        RTcmix.setpfieldRTcmix(3, srcpos.y, objno);
    }

    // called once for each sample-buffer. data[] contains incoming and outgoing samples
    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0); // set "0" to "1" for input processing

        if (RTcmix.checkbangRTcmix(objno) == 1)
        {
            RTcmix.SendScore("STEREO(0, 0.7, 0.5, 1, 0.5)  MAXBANG(0.5)", objno);
        }

        RTcmix.printRTcmix(objno);
    }

    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
